﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.IO;
using System.Web.UI.WebControls;

namespace iX.MeinWeinkeller.DAO
{
    /// <summary>
    /// FileDAO liest und speichert Bilddateien im Dateisystem
    /// </summary>
    public class FileDAO
    {
        /// <summary>
        /// Bilddatei aus einem File-Upload-Objekt speichern
        /// </summary>
        /// <param name="strBasePath">Verzeichnispfad</param>
        /// <param name="id">id des Datensatzes</param>
        /// <param name="fu">File-Upload-Objekt</param>
        public static void SaveFile(string strBasePath, int id, FileUpload fu)
        {
            // Alle Dateien zur id löschen
            string[] files = Directory.GetFiles(strBasePath, id.ToString() + "*");
            foreach (string file in files)
                File.Delete(file);

            // Dateierweiterung ermitteln
            string fn = fu.FileName;
            string ext = fn.Substring(fn.LastIndexOf(".") + 1);

            // Datei speichern
            fu.SaveAs(strBasePath + "\\" + id.ToString() + "." + ext);
        }

        /// <summary>
        /// Dateiname des Bildes eines Datensatzes holen
        /// </summary>
        /// <param name="strBasePath">Verzeichnispfad</param>
        /// <param name="id">id des Datensatzes</param>
        /// <returns></returns>
        public static string GetFile(string strBasePath, int id)
        {
            string path = null;

            // Dateien suchen
            string[] files = Directory.GetFiles(strBasePath, id.ToString() + ".*");

            // Die erste gefundene Datei ermittlen
            if (files.GetLength(0) > 0)
            {
                path = files[0];
                path = path.Substring(path.LastIndexOf("\\") + 1);
            }

            // Datei zurückgeben
            return path;
        }

        /// <summary>
        /// Bilddateien eines Datensatzes löschen
        /// </summary>
        /// <param name="strBasePath">Verzeichnispfad</param>
        /// <param name="id">id des Datensatzes</param>
        public static void DeleteFile(string strBasePath, int id)
        {
            // Alle Dateien zur id löschen
            string[] files = Directory.GetFiles(strBasePath, id.ToString() + "*");
            foreach (string file in files)
                File.Delete(file);
        }

    }
}
