package com.abien.winery.business.winesearch.domain;

import java.util.ArrayList;
import java.util.Collection;
import javax.persistence.CascadeType;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.OneToMany;

/**
 *
 * @author abien-bien.com
 */
@Entity
public class Winery{
    @Id
    @GeneratedValue(strategy = GenerationType.AUTO)
    private Long id;

    private String name;
    private String address;
    private String region;

    @OneToMany(cascade=CascadeType.ALL)
    private Collection<WineCellar> cellars;

    public Winery() {
        this.cellars = new ArrayList<WineCellar>();
    }

    public Winery(String name, String address, String region) {
        this();
        this.name = name;
        this.address = address;
        this.region = region;
    }

    public Winery add(WineCellar wineCellar) {
        cellars.add(wineCellar);
        return this;
    }

    public Winery remove(WineCellar cellar) {
        cellars.remove(cellar);
        return this;
    }
}
