<?php

/**
 * lagert actions.
 *
 * @package    weinkeller
 * @subpackage lagert
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 12474 2008-10-31 10:41:27Z fabien $
 */
class lagertActions extends sfActions
{
  public function executeIndex(sfWebRequest $request)
  {
    $this->lagert_list = LagertPeer::doSelect(new Criteria());
  }

  public function executeShow(sfWebRequest $request)
  {
    $this->lagert = LagertPeer::retrieveByPk($request->getParameter('weinid'),
                                     $request->getParameter('wkid'));
    $this->forward404Unless($this->lagert);
  }

  public function executeNew(sfWebRequest $request)
  {
    $this->form = new LagertForm();
  }

  public function executeCreate(sfWebRequest $request)
  {
    $this->forward404Unless($request->isMethod('post'));

    $this->form = new LagertForm();

    $this->processForm($request, $this->form);

    $this->setTemplate('new');
  }

  public function executeEdit(sfWebRequest $request)
  {
    $this->forward404Unless($lagert = LagertPeer::retrieveByPk($request->getParameter('weinid'),
                               $request->getParameter('wkid')), sprintf('Object lagert does not exist (%s).', $request->getParameter('weinid'),
                               $request->getParameter('wkid')));
    $this->form = new LagertForm($lagert);
  }

  public function executeUpdate(sfWebRequest $request)
  {
    $this->forward404Unless($request->isMethod('post') || $request->isMethod('put'));
    $this->forward404Unless($lagert = LagertPeer::retrieveByPk($request->getParameter('weinid'),
                               $request->getParameter('wkid')), sprintf('Object lagert does not exist (%s).', $request->getParameter('weinid'),
                               $request->getParameter('wkid')));
    $this->form = new LagertForm($lagert);

    $this->processForm($request, $this->form);

    $this->setTemplate('edit');
  }

  public function executeDelete(sfWebRequest $request)
  {
    $request->checkCSRFProtection();

    $this->forward404Unless($lagert = LagertPeer::retrieveByPk($request->getParameter('weinid'),
                               $request->getParameter('wkid')), sprintf('Object lagert does not exist (%s).', $request->getParameter('weinid'),
                               $request->getParameter('wkid')));
    $lagert->delete();

    $this->redirect('lagert/index');
  }

  protected function processForm(sfWebRequest $request, sfForm $form)
  {
    $form->bind($request->getParameter($form->getName()), $request->getFiles($form->getName()));
    if ($form->isValid())
    {
      $lagert = $form->save();

      $this->redirect('lagert/edit?weinid='.$lagert->getWeinid().'&wkid='.$lagert->getWkid());
    }
  }
}
