<?php

/**
 * wein actions.
 *
 * @package    weinkeller
 * @subpackage wein
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 12474 2008-10-31 10:41:27Z fabien $
 */
class weinActions extends sfActions
{
  public function executeIndex(sfWebRequest $request)
  {
    $this->wein_list = WeinPeer::doSelect(new Criteria());
  }

  public function executeShow(sfWebRequest $request)
  {
    $this->wein = WeinPeer::retrieveByPk($request->getParameter('weinid'));
    $this->forward404Unless($this->wein);
  }

  public function executeNew(sfWebRequest $request)
  {
    $this->form = new WeinForm();
  }

  public function executeCreate(sfWebRequest $request)
  {
    $this->forward404Unless($request->isMethod('post'));

    $this->form = new WeinForm();

    $this->processForm($request, $this->form);

    $this->setTemplate('new');
  }

  public function executeEdit(sfWebRequest $request)
  {
    $this->forward404Unless($wein = WeinPeer::retrieveByPk($request->getParameter('weinid')), sprintf('Object wein does not exist (%s).', $request->getParameter('weinid')));
    $this->form = new WeinForm($wein);
  }

  public function executeUpdate(sfWebRequest $request)
  {
    $this->forward404Unless($request->isMethod('post') || $request->isMethod('put'));
    $this->forward404Unless($wein = WeinPeer::retrieveByPk($request->getParameter('weinid')), sprintf('Object wein does not exist (%s).', $request->getParameter('weinid')));
    $this->form = new WeinForm($wein);

    $this->processForm($request, $this->form);

    $this->setTemplate('edit');
  }

  public function executeDelete(sfWebRequest $request)
  {
    $request->checkCSRFProtection();

    $this->forward404Unless($wein = WeinPeer::retrieveByPk($request->getParameter('weinid')), sprintf('Object wein does not exist (%s).', $request->getParameter('weinid')));
    $wein->delete();

    $this->redirect('wein/index');
  }

  protected function processForm(sfWebRequest $request, sfForm $form)
  {
    $form->bind($request->getParameter($form->getName()), $request->getFiles($form->getName()));
    if ($form->isValid())
    {
      $wein = $form->save();

      $this->redirect('wein/edit?weinid='.$wein->getWeinid());
    }
  }
}
