<?php

/**
 * weingut actions.
 *
 * @package    weinkeller
 * @subpackage weingut
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 12474 2008-10-31 10:41:27Z fabien $
 */
class weingutActions extends sfActions
{
  public function executeIndex(sfWebRequest $request)
  {
    $this->weingut_list = WeingutPeer::doSelect(new Criteria());
  }

  public function executeShow(sfWebRequest $request)
  {
    $this->weingut = WeingutPeer::retrieveByPk($request->getParameter('wgid'));
    $this->forward404Unless($this->weingut);
  }

  public function executeNew(sfWebRequest $request)
  {
    $this->form = new WeingutForm();
  }

  public function executeCreate(sfWebRequest $request)
  {
    $this->forward404Unless($request->isMethod('post'));

    $this->form = new WeingutForm();

    $this->processForm($request, $this->form);

    $this->setTemplate('new');
  }

  public function executeEdit(sfWebRequest $request)
  {
    $this->forward404Unless($weingut = WeingutPeer::retrieveByPk($request->getParameter('wgid')), sprintf('Object weingut does not exist (%s).', $request->getParameter('wgid')));
    $this->form = new WeingutForm($weingut);
  }

  public function executeUpdate(sfWebRequest $request)
  {
    $this->forward404Unless($request->isMethod('post') || $request->isMethod('put'));
    $this->forward404Unless($weingut = WeingutPeer::retrieveByPk($request->getParameter('wgid')), sprintf('Object weingut does not exist (%s).', $request->getParameter('wgid')));
    $this->form = new WeingutForm($weingut);

    $this->processForm($request, $this->form);

    $this->setTemplate('edit');
  }

  public function executeDelete(sfWebRequest $request)
  {
    $request->checkCSRFProtection();

    $this->forward404Unless($weingut = WeingutPeer::retrieveByPk($request->getParameter('wgid')), sprintf('Object weingut does not exist (%s).', $request->getParameter('wgid')));
    $weingut->delete();

    $this->redirect('weingut/index');
  }

  protected function processForm(sfWebRequest $request, sfForm $form)
  {
    $form->bind($request->getParameter($form->getName()), $request->getFiles($form->getName()));
    if ($form->isValid())
    {
      $weingut = $form->save();

      $this->redirect('weingut/edit?wgid='.$weingut->getWgid());
    }
  }
}
