<?php

/**
 * weinkeller actions.
 *
 * @package    weinkeller
 * @subpackage weinkeller
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 12474 2008-10-31 10:41:27Z fabien $
 */
class weinkellerActions extends sfActions
{
  public function executeIndex(sfWebRequest $request)
  {
    $this->weinkeller_list = WeinkellerPeer::doSelect(new Criteria());
  }

  public function executeShow(sfWebRequest $request)
  {
    $this->weinkeller = WeinkellerPeer::retrieveByPk($request->getParameter('wkid'));
    $this->forward404Unless($this->weinkeller);
  }

  public function executeNew(sfWebRequest $request)
  {
    $this->form = new WeinkellerForm();
  }

  public function executeCreate(sfWebRequest $request)
  {
    $this->forward404Unless($request->isMethod('post'));

    $this->form = new WeinkellerForm();

    $this->processForm($request, $this->form);

    $this->setTemplate('new');
  }

  public function executeEdit(sfWebRequest $request)
  {
    $this->forward404Unless($weinkeller = WeinkellerPeer::retrieveByPk($request->getParameter('wkid')), sprintf('Object weinkeller does not exist (%s).', $request->getParameter('wkid')));
    $this->form = new WeinkellerForm($weinkeller);
  }

  public function executeUpdate(sfWebRequest $request)
  {
    $this->forward404Unless($request->isMethod('post') || $request->isMethod('put'));
    $this->forward404Unless($weinkeller = WeinkellerPeer::retrieveByPk($request->getParameter('wkid')), sprintf('Object weinkeller does not exist (%s).', $request->getParameter('wkid')));
    $this->form = new WeinkellerForm($weinkeller);

    $this->processForm($request, $this->form);

    $this->setTemplate('edit');
  }

  public function executeDelete(sfWebRequest $request)
  {
    $request->checkCSRFProtection();

    $this->forward404Unless($weinkeller = WeinkellerPeer::retrieveByPk($request->getParameter('wkid')), sprintf('Object weinkeller does not exist (%s).', $request->getParameter('wkid')));
    $weinkeller->delete();

    $this->redirect('weinkeller/index');
  }

  protected function processForm(sfWebRequest $request, sfForm $form)
  {
    $form->bind($request->getParameter($form->getName()), $request->getFiles($form->getName()));
    if ($form->isValid())
    {
      $weinkeller = $form->save();

      $this->redirect('weinkeller/edit?wkid='.$weinkeller->getWkid());
    }
  }
}
