
# This is a fix for InnoDB in MySQL >= 4.1.x
# It "suspends judgement" for fkey relationships until are tables are set.
SET FOREIGN_KEY_CHECKS = 0;

#-----------------------------------------------------------------------------
#-- Wein
#-----------------------------------------------------------------------------

DROP TABLE IF EXISTS `Wein`;


CREATE TABLE `Wein`
(
	`weinid` INTEGER  NOT NULL AUTO_INCREMENT,
	`name` VARCHAR(32),
	`alter` INTEGER,
	`preis` DECIMAL,
	`wgid` INTEGER  NOT NULL,
	PRIMARY KEY (`weinid`),
	INDEX `Wein_FI_1` (`wgid`),
	CONSTRAINT `Wein_FK_1`
		FOREIGN KEY (`wgid`)
		REFERENCES `Weingut` (`wgid`)
)Type=InnoDB;

#-----------------------------------------------------------------------------
#-- Weingut
#-----------------------------------------------------------------------------

DROP TABLE IF EXISTS `Weingut`;


CREATE TABLE `Weingut`
(
	`wgid` INTEGER  NOT NULL AUTO_INCREMENT,
	`name` VARCHAR(32),
	`adresse` VARCHAR(32),
	`anbaugebiet` VARCHAR(32),
	PRIMARY KEY (`wgid`)
)Type=InnoDB;

#-----------------------------------------------------------------------------
#-- Weinkeller
#-----------------------------------------------------------------------------

DROP TABLE IF EXISTS `Weinkeller`;


CREATE TABLE `Weinkeller`
(
	`wkid` INTEGER  NOT NULL AUTO_INCREMENT,
	`Name` VARCHAR(32),
	`ort` VARCHAR(32),
	PRIMARY KEY (`wkid`)
)Type=InnoDB;

#-----------------------------------------------------------------------------
#-- Lagert
#-----------------------------------------------------------------------------

DROP TABLE IF EXISTS `Lagert`;


CREATE TABLE `Lagert`
(
	`weinid` INTEGER  NOT NULL,
	`wkid` INTEGER  NOT NULL,
	PRIMARY KEY (`weinid`,`wkid`),
	CONSTRAINT `Lagert_FK_1`
		FOREIGN KEY (`weinid`)
		REFERENCES `Wein` (`weinid`),
	INDEX `Lagert_FI_2` (`wkid`),
	CONSTRAINT `Lagert_FK_2`
		FOREIGN KEY (`wkid`)
		REFERENCES `Weinkeller` (`wkid`)
)Type=InnoDB;

# This restores the fkey checks, after having unset them earlier
SET FOREIGN_KEY_CHECKS = 1;
