<?php

/**
 * Weinkeller form base class.
 *
 * @package    weinkeller
 * @subpackage form
 * @author     Your name here
 * @version    SVN: $Id: sfPropelFormGeneratedTemplate.php 15484 2009-02-13 13:13:51Z fabien $
 */
class BaseWeinkellerForm extends BaseFormPropel
{
  public function setup()
  {
    $this->setWidgets(array(
      'wkid'        => new sfWidgetFormInputHidden(),
      'name'        => new sfWidgetFormInput(),
      'ort'         => new sfWidgetFormInput(),
      'lagert_list' => new sfWidgetFormPropelChoiceMany(array('model' => 'Wein')),
    ));

    $this->setValidators(array(
      'wkid'        => new sfValidatorPropelChoice(array('model' => 'Weinkeller', 'column' => 'wkid', 'required' => false)),
      'name'        => new sfValidatorString(array('max_length' => 32, 'required' => false)),
      'ort'         => new sfValidatorString(array('max_length' => 32, 'required' => false)),
      'lagert_list' => new sfValidatorPropelChoiceMany(array('model' => 'Wein', 'required' => false)),
    ));

    $this->widgetSchema->setNameFormat('weinkeller[%s]');

    $this->errorSchema = new sfValidatorErrorSchema($this->validatorSchema);

    parent::setup();
  }

  public function getModelName()
  {
    return 'Weinkeller';
  }


  public function updateDefaultsFromObject()
  {
    parent::updateDefaultsFromObject();

    if (isset($this->widgetSchema['lagert_list']))
    {
      $values = array();
      foreach ($this->object->getLagerts() as $obj)
      {
        $values[] = $obj->getWeinid();
      }

      $this->setDefault('lagert_list', $values);
    }

  }

  protected function doSave($con = null)
  {
    parent::doSave($con);

    $this->saveLagertList($con);
  }

  public function saveLagertList($con = null)
  {
    if (!$this->isValid())
    {
      throw $this->getErrorSchema();
    }

    if (!isset($this->widgetSchema['lagert_list']))
    {
      // somebody has unset this widget
      return;
    }

    if (is_null($con))
    {
      $con = $this->getConnection();
    }

    $c = new Criteria();
    $c->add(LagertPeer::WKID, $this->object->getPrimaryKey());
    LagertPeer::doDelete($c, $con);

    $values = $this->getValue('lagert_list');
    if (is_array($values))
    {
      foreach ($values as $value)
      {
        $obj = new Lagert();
        $obj->setWkid($this->object->getPrimaryKey());
        $obj->setWeinid($value);
        $obj->save();
      }
    }
  }

}
