<?php

/**
 * Base class that represents a row from the 'Wein' table.
 *
 * 
 *
 * This class was autogenerated by Propel 1.3.0-dev on:
 *
 * Tue Mar 31 10:45:23 2009
 *
 * @package    lib.model.om
 */
abstract class BaseWein extends BaseObject  implements Persistent {


  const PEER = 'WeinPeer';

	/**
	 * The Peer class.
	 * Instance provides a convenient way of calling static methods on a class
	 * that calling code may not be able to identify.
	 * @var        WeinPeer
	 */
	protected static $peer;

	/**
	 * The value for the weinid field.
	 * @var        int
	 */
	protected $weinid;

	/**
	 * The value for the name field.
	 * @var        string
	 */
	protected $name;

	/**
	 * The value for the alter field.
	 * @var        int
	 */
	protected $alter;

	/**
	 * The value for the preis field.
	 * @var        string
	 */
	protected $preis;

	/**
	 * The value for the wgid field.
	 * @var        int
	 */
	protected $wgid;

	/**
	 * @var        Weingut
	 */
	protected $aWeingut;

	/**
	 * @var        array Lagert[] Collection to store aggregation of Lagert objects.
	 */
	protected $collLagerts;

	/**
	 * @var        Criteria The criteria used to select the current contents of collLagerts.
	 */
	private $lastLagertCriteria = null;

	/**
	 * Flag to prevent endless save loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var        boolean
	 */
	protected $alreadyInSave = false;

	/**
	 * Flag to prevent endless validation loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var        boolean
	 */
	protected $alreadyInValidation = false;

	/**
	 * Initializes internal state of BaseWein object.
	 * @see        applyDefaults()
	 */
	public function __construct()
	{
		parent::__construct();
		$this->applyDefaultValues();
	}

	/**
	 * Applies default values to this object.
	 * This method should be called from the object's constructor (or
	 * equivalent initialization method).
	 * @see        __construct()
	 */
	public function applyDefaultValues()
	{
	}

	/**
	 * Get the [weinid] column value.
	 * 
	 * @return     int
	 */
	public function getWeinid()
	{
		return $this->weinid;
	}

	/**
	 * Get the [name] column value.
	 * 
	 * @return     string
	 */
	public function getName()
	{
		return $this->name;
	}

	/**
	 * Get the [alter] column value.
	 * 
	 * @return     int
	 */
	public function getAlter()
	{
		return $this->alter;
	}

	/**
	 * Get the [preis] column value.
	 * 
	 * @return     string
	 */
	public function getPreis()
	{
		return $this->preis;
	}

	/**
	 * Get the [wgid] column value.
	 * 
	 * @return     int
	 */
	public function getWgid()
	{
		return $this->wgid;
	}

	/**
	 * Set the value of [weinid] column.
	 * 
	 * @param      int $v new value
	 * @return     Wein The current object (for fluent API support)
	 */
	public function setWeinid($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->weinid !== $v) {
			$this->weinid = $v;
			$this->modifiedColumns[] = WeinPeer::WEINID;
		}

		return $this;
	} // setWeinid()

	/**
	 * Set the value of [name] column.
	 * 
	 * @param      string $v new value
	 * @return     Wein The current object (for fluent API support)
	 */
	public function setName($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->name !== $v) {
			$this->name = $v;
			$this->modifiedColumns[] = WeinPeer::NAME;
		}

		return $this;
	} // setName()

	/**
	 * Set the value of [alter] column.
	 * 
	 * @param      int $v new value
	 * @return     Wein The current object (for fluent API support)
	 */
	public function setAlter($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->alter !== $v) {
			$this->alter = $v;
			$this->modifiedColumns[] = WeinPeer::ALTER;
		}

		return $this;
	} // setAlter()

	/**
	 * Set the value of [preis] column.
	 * 
	 * @param      string $v new value
	 * @return     Wein The current object (for fluent API support)
	 */
	public function setPreis($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->preis !== $v) {
			$this->preis = $v;
			$this->modifiedColumns[] = WeinPeer::PREIS;
		}

		return $this;
	} // setPreis()

	/**
	 * Set the value of [wgid] column.
	 * 
	 * @param      int $v new value
	 * @return     Wein The current object (for fluent API support)
	 */
	public function setWgid($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->wgid !== $v) {
			$this->wgid = $v;
			$this->modifiedColumns[] = WeinPeer::WGID;
		}

		if ($this->aWeingut !== null && $this->aWeingut->getWgid() !== $v) {
			$this->aWeingut = null;
		}

		return $this;
	} // setWgid()

	/**
	 * Indicates whether the columns in this object are only set to default values.
	 *
	 * This method can be used in conjunction with isModified() to indicate whether an object is both
	 * modified _and_ has some values set which are non-default.
	 *
	 * @return     boolean Whether the columns in this object are only been set with default values.
	 */
	public function hasOnlyDefaultValues()
	{
			// First, ensure that we don't have any columns that have been modified which aren't default columns.
			if (array_diff($this->modifiedColumns, array())) {
				return false;
			}

		// otherwise, everything was equal, so return TRUE
		return true;
	} // hasOnlyDefaultValues()

	/**
	 * Hydrates (populates) the object variables with values from the database resultset.
	 *
	 * An offset (0-based "start column") is specified so that objects can be hydrated
	 * with a subset of the columns in the resultset rows.  This is needed, for example,
	 * for results of JOIN queries where the resultset row includes columns from two or
	 * more tables.
	 *
	 * @param      array $row The row returned by PDOStatement->fetch(PDO::FETCH_NUM)
	 * @param      int $startcol 0-based offset column which indicates which restultset column to start with.
	 * @param      boolean $rehydrate Whether this object is being re-hydrated from the database.
	 * @return     int next starting column
	 * @throws     PropelException  - Any caught Exception will be rewrapped as a PropelException.
	 */
	public function hydrate($row, $startcol = 0, $rehydrate = false)
	{
		try {

			$this->weinid = ($row[$startcol + 0] !== null) ? (int) $row[$startcol + 0] : null;
			$this->name = ($row[$startcol + 1] !== null) ? (string) $row[$startcol + 1] : null;
			$this->alter = ($row[$startcol + 2] !== null) ? (int) $row[$startcol + 2] : null;
			$this->preis = ($row[$startcol + 3] !== null) ? (string) $row[$startcol + 3] : null;
			$this->wgid = ($row[$startcol + 4] !== null) ? (int) $row[$startcol + 4] : null;
			$this->resetModified();

			$this->setNew(false);

			if ($rehydrate) {
				$this->ensureConsistency();
			}

			// FIXME - using NUM_COLUMNS may be clearer.
			return $startcol + 5; // 5 = WeinPeer::NUM_COLUMNS - WeinPeer::NUM_LAZY_LOAD_COLUMNS).

		} catch (Exception $e) {
			throw new PropelException("Error populating Wein object", $e);
		}
	}

	/**
	 * Checks and repairs the internal consistency of the object.
	 *
	 * This method is executed after an already-instantiated object is re-hydrated
	 * from the database.  It exists to check any foreign keys to make sure that
	 * the objects related to the current object are correct based on foreign key.
	 *
	 * You can override this method in the stub class, but you should always invoke
	 * the base method from the overridden method (i.e. parent::ensureConsistency()),
	 * in case your model changes.
	 *
	 * @throws     PropelException
	 */
	public function ensureConsistency()
	{

		if ($this->aWeingut !== null && $this->wgid !== $this->aWeingut->getWgid()) {
			$this->aWeingut = null;
		}
	} // ensureConsistency

	/**
	 * Reloads this object from datastore based on primary key and (optionally) resets all associated objects.
	 *
	 * This will only work if the object has been saved and has a valid primary key set.
	 *
	 * @param      boolean $deep (optional) Whether to also de-associated any related objects.
	 * @param      PropelPDO $con (optional) The PropelPDO connection to use.
	 * @return     void
	 * @throws     PropelException - if this object is deleted, unsaved or doesn't have pk match in db
	 */
	public function reload($deep = false, PropelPDO $con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("Cannot reload a deleted object.");
		}

		if ($this->isNew()) {
			throw new PropelException("Cannot reload an unsaved object.");
		}

		if ($con === null) {
			$con = Propel::getConnection(WeinPeer::DATABASE_NAME, Propel::CONNECTION_READ);
		}

		// We don't need to alter the object instance pool; we're just modifying this instance
		// already in the pool.

		$stmt = WeinPeer::doSelectStmt($this->buildPkeyCriteria(), $con);
		$row = $stmt->fetch(PDO::FETCH_NUM);
		$stmt->closeCursor();
		if (!$row) {
			throw new PropelException('Cannot find matching row in the database to reload object values.');
		}
		$this->hydrate($row, 0, true); // rehydrate

		if ($deep) {  // also de-associate any related objects?

			$this->aWeingut = null;
			$this->collLagerts = null;
			$this->lastLagertCriteria = null;

		} // if (deep)
	}

	/**
	 * Removes this object from datastore and sets delete attribute.
	 *
	 * @param      PropelPDO $con
	 * @return     void
	 * @throws     PropelException
	 * @see        BaseObject::setDeleted()
	 * @see        BaseObject::isDeleted()
	 */
	public function delete(PropelPDO $con = null)
	{

    foreach (sfMixer::getCallables('BaseWein:delete:pre') as $callable)
    {
      $ret = call_user_func($callable, $this, $con);
      if ($ret)
      {
        return;
      }
    }


		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(WeinPeer::DATABASE_NAME, Propel::CONNECTION_WRITE);
		}
		
		$con->beginTransaction();
		try {
			WeinPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollBack();
			throw $e;
		}
	

    foreach (sfMixer::getCallables('BaseWein:delete:post') as $callable)
    {
      call_user_func($callable, $this, $con);
    }

  }
	/**
	 * Persists this object to the database.
	 *
	 * If the object is new, it inserts it; otherwise an update is performed.
	 * All modified related objects will also be persisted in the doSave()
	 * method.  This method wraps all precipitate database operations in a
	 * single transaction.
	 *
	 * @param      PropelPDO $con
	 * @return     int The number of rows affected by this insert/update and any referring fk objects' save() operations.
	 * @throws     PropelException
	 * @see        doSave()
	 */
	public function save(PropelPDO $con = null)
	{

    foreach (sfMixer::getCallables('BaseWein:save:pre') as $callable)
    {
      $affectedRows = call_user_func($callable, $this, $con);
      if (is_int($affectedRows))
      {
        return $affectedRows;
      }
    }


		if ($this->isDeleted()) {
			throw new PropelException("You cannot save an object that has been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(WeinPeer::DATABASE_NAME, Propel::CONNECTION_WRITE);
		}
		
		$con->beginTransaction();
		try {
			$affectedRows = $this->doSave($con);
			$con->commit();
    foreach (sfMixer::getCallables('BaseWein:save:post') as $callable)
    {
      call_user_func($callable, $this, $con, $affectedRows);
    }

			WeinPeer::addInstanceToPool($this);
			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollBack();
			throw $e;
		}
	}

	/**
	 * Performs the work of inserting or updating the row in the database.
	 *
	 * If the object is new, it inserts it; otherwise an update is performed.
	 * All related objects are also updated in this method.
	 *
	 * @param      PropelPDO $con
	 * @return     int The number of rows affected by this insert/update and any referring fk objects' save() operations.
	 * @throws     PropelException
	 * @see        save()
	 */
	protected function doSave(PropelPDO $con)
	{
		$affectedRows = 0; // initialize var to track total num of affected rows
		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;

			// We call the save method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.

			if ($this->aWeingut !== null) {
				if ($this->aWeingut->isModified() || $this->aWeingut->isNew()) {
					$affectedRows += $this->aWeingut->save($con);
				}
				$this->setWeingut($this->aWeingut);
			}

			if ($this->isNew() ) {
				$this->modifiedColumns[] = WeinPeer::WEINID;
			}

			// If this object has been modified, then save it to the database.
			if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = WeinPeer::doInsert($this, $con);
					$affectedRows += 1; // we are assuming that there is only 1 row per doInsert() which
										 // should always be true here (even though technically
										 // BasePeer::doInsert() can insert multiple rows).

					$this->setWeinid($pk);  //[IMV] update autoincrement primary key

					$this->setNew(false);
				} else {
					$affectedRows += WeinPeer::doUpdate($this, $con);
				}

				$this->resetModified(); // [HL] After being saved an object is no longer 'modified'
			}

			if ($this->collLagerts !== null) {
				foreach ($this->collLagerts as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			$this->alreadyInSave = false;

		}
		return $affectedRows;
	} // doSave()

	/**
	 * Array of ValidationFailed objects.
	 * @var        array ValidationFailed[]
	 */
	protected $validationFailures = array();

	/**
	 * Gets any ValidationFailed objects that resulted from last call to validate().
	 *
	 *
	 * @return     array ValidationFailed[]
	 * @see        validate()
	 */
	public function getValidationFailures()
	{
		return $this->validationFailures;
	}

	/**
	 * Validates the objects modified field values and all objects related to this table.
	 *
	 * If $columns is either a column name or an array of column names
	 * only those columns are validated.
	 *
	 * @param      mixed $columns Column name or an array of column names.
	 * @return     boolean Whether all columns pass validation.
	 * @see        doValidate()
	 * @see        getValidationFailures()
	 */
	public function validate($columns = null)
	{
		$res = $this->doValidate($columns);
		if ($res === true) {
			$this->validationFailures = array();
			return true;
		} else {
			$this->validationFailures = $res;
			return false;
		}
	}

	/**
	 * This function performs the validation work for complex object models.
	 *
	 * In addition to checking the current object, all related objects will
	 * also be validated.  If all pass then <code>true</code> is returned; otherwise
	 * an aggreagated array of ValidationFailed objects will be returned.
	 *
	 * @param      array $columns Array of column names to validate.
	 * @return     mixed <code>true</code> if all validations pass; array of <code>ValidationFailed</code> objets otherwise.
	 */
	protected function doValidate($columns = null)
	{
		if (!$this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;

			$failureMap = array();


			// We call the validate method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.

			if ($this->aWeingut !== null) {
				if (!$this->aWeingut->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aWeingut->getValidationFailures());
				}
			}


			if (($retval = WeinPeer::doValidate($this, $columns)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}


				if ($this->collLagerts !== null) {
					foreach ($this->collLagerts as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}


			$this->alreadyInValidation = false;
		}

		return (!empty($failureMap) ? $failureMap : true);
	}

	/**
	 * Retrieves a field from the object by name passed in as a string.
	 *
	 * @param      string $name name
	 * @param      string $type The type of fieldname the $name is of:
	 *                     one of the class type constants BasePeer::TYPE_PHPNAME, BasePeer::TYPE_STUDLYPHPNAME
	 *                     BasePeer::TYPE_COLNAME, BasePeer::TYPE_FIELDNAME, BasePeer::TYPE_NUM
	 * @return     mixed Value of field.
	 */
	public function getByName($name, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = WeinPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		$field = $this->getByPosition($pos);
		return $field;
	}

	/**
	 * Retrieves a field from the object by Position as specified in the xml schema.
	 * Zero-based.
	 *
	 * @param      int $pos position in xml schema
	 * @return     mixed Value of field at $pos
	 */
	public function getByPosition($pos)
	{
		switch($pos) {
			case 0:
				return $this->getWeinid();
				break;
			case 1:
				return $this->getName();
				break;
			case 2:
				return $this->getAlter();
				break;
			case 3:
				return $this->getPreis();
				break;
			case 4:
				return $this->getWgid();
				break;
			default:
				return null;
				break;
		} // switch()
	}

	/**
	 * Exports the object as an array.
	 *
	 * You can specify the key type of the array by passing one of the class
	 * type constants.
	 *
	 * @param      string $keyType (optional) One of the class type constants BasePeer::TYPE_PHPNAME, BasePeer::TYPE_STUDLYPHPNAME
	 *                        BasePeer::TYPE_COLNAME, BasePeer::TYPE_FIELDNAME, BasePeer::TYPE_NUM. Defaults to BasePeer::TYPE_PHPNAME.
	 * @param      boolean $includeLazyLoadColumns (optional) Whether to include lazy loaded columns.  Defaults to TRUE.
	 * @return     an associative array containing the field names (as keys) and field values
	 */
	public function toArray($keyType = BasePeer::TYPE_PHPNAME, $includeLazyLoadColumns = true)
	{
		$keys = WeinPeer::getFieldNames($keyType);
		$result = array(
			$keys[0] => $this->getWeinid(),
			$keys[1] => $this->getName(),
			$keys[2] => $this->getAlter(),
			$keys[3] => $this->getPreis(),
			$keys[4] => $this->getWgid(),
		);
		return $result;
	}

	/**
	 * Sets a field from the object by name passed in as a string.
	 *
	 * @param      string $name peer name
	 * @param      mixed $value field value
	 * @param      string $type The type of fieldname the $name is of:
	 *                     one of the class type constants BasePeer::TYPE_PHPNAME, BasePeer::TYPE_STUDLYPHPNAME
	 *                     BasePeer::TYPE_COLNAME, BasePeer::TYPE_FIELDNAME, BasePeer::TYPE_NUM
	 * @return     void
	 */
	public function setByName($name, $value, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = WeinPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->setByPosition($pos, $value);
	}

	/**
	 * Sets a field from the object by Position as specified in the xml schema.
	 * Zero-based.
	 *
	 * @param      int $pos position in xml schema
	 * @param      mixed $value field value
	 * @return     void
	 */
	public function setByPosition($pos, $value)
	{
		switch($pos) {
			case 0:
				$this->setWeinid($value);
				break;
			case 1:
				$this->setName($value);
				break;
			case 2:
				$this->setAlter($value);
				break;
			case 3:
				$this->setPreis($value);
				break;
			case 4:
				$this->setWgid($value);
				break;
		} // switch()
	}

	/**
	 * Populates the object using an array.
	 *
	 * This is particularly useful when populating an object from one of the
	 * request arrays (e.g. $_POST).  This method goes through the column
	 * names, checking to see whether a matching key exists in populated
	 * array. If so the setByName() method is called for that column.
	 *
	 * You can specify the key type of the array by additionally passing one
	 * of the class type constants BasePeer::TYPE_PHPNAME, BasePeer::TYPE_STUDLYPHPNAME,
	 * BasePeer::TYPE_COLNAME, BasePeer::TYPE_FIELDNAME, BasePeer::TYPE_NUM.
	 * The default key type is the column's phpname (e.g. 'AuthorId')
	 *
	 * @param      array  $arr     An array to populate the object from.
	 * @param      string $keyType The type of keys the array uses.
	 * @return     void
	 */
	public function fromArray($arr, $keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = WeinPeer::getFieldNames($keyType);

		if (array_key_exists($keys[0], $arr)) $this->setWeinid($arr[$keys[0]]);
		if (array_key_exists($keys[1], $arr)) $this->setName($arr[$keys[1]]);
		if (array_key_exists($keys[2], $arr)) $this->setAlter($arr[$keys[2]]);
		if (array_key_exists($keys[3], $arr)) $this->setPreis($arr[$keys[3]]);
		if (array_key_exists($keys[4], $arr)) $this->setWgid($arr[$keys[4]]);
	}

	/**
	 * Build a Criteria object containing the values of all modified columns in this object.
	 *
	 * @return     Criteria The Criteria object containing all modified values.
	 */
	public function buildCriteria()
	{
		$criteria = new Criteria(WeinPeer::DATABASE_NAME);

		if ($this->isColumnModified(WeinPeer::WEINID)) $criteria->add(WeinPeer::WEINID, $this->weinid);
		if ($this->isColumnModified(WeinPeer::NAME)) $criteria->add(WeinPeer::NAME, $this->name);
		if ($this->isColumnModified(WeinPeer::ALTER)) $criteria->add(WeinPeer::ALTER, $this->alter);
		if ($this->isColumnModified(WeinPeer::PREIS)) $criteria->add(WeinPeer::PREIS, $this->preis);
		if ($this->isColumnModified(WeinPeer::WGID)) $criteria->add(WeinPeer::WGID, $this->wgid);

		return $criteria;
	}

	/**
	 * Builds a Criteria object containing the primary key for this object.
	 *
	 * Unlike buildCriteria() this method includes the primary key values regardless
	 * of whether or not they have been modified.
	 *
	 * @return     Criteria The Criteria object containing value(s) for primary key(s).
	 */
	public function buildPkeyCriteria()
	{
		$criteria = new Criteria(WeinPeer::DATABASE_NAME);

		$criteria->add(WeinPeer::WEINID, $this->weinid);

		return $criteria;
	}

	/**
	 * Returns the primary key for this object (row).
	 * @return     int
	 */
	public function getPrimaryKey()
	{
		return $this->getWeinid();
	}

	/**
	 * Generic method to set the primary key (weinid column).
	 *
	 * @param      int $key Primary key.
	 * @return     void
	 */
	public function setPrimaryKey($key)
	{
		$this->setWeinid($key);
	}

	/**
	 * Sets contents of passed object to values from current object.
	 *
	 * If desired, this method can also make copies of all associated (fkey referrers)
	 * objects.
	 *
	 * @param      object $copyObj An object of Wein (or compatible) type.
	 * @param      boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
	 * @throws     PropelException
	 */
	public function copyInto($copyObj, $deepCopy = false)
	{

		$copyObj->setName($this->name);

		$copyObj->setAlter($this->alter);

		$copyObj->setPreis($this->preis);

		$copyObj->setWgid($this->wgid);


		if ($deepCopy) {
			// important: temporarily setNew(false) because this affects the behavior of
			// the getter/setter methods for fkey referrer objects.
			$copyObj->setNew(false);

			foreach ($this->getLagerts() as $relObj) {
				if ($relObj !== $this) {  // ensure that we don't try to copy a reference to ourselves
					$copyObj->addLagert($relObj->copy($deepCopy));
				}
			}

		} // if ($deepCopy)


		$copyObj->setNew(true);

		$copyObj->setWeinid(NULL); // this is a auto-increment column, so set to default value

	}

	/**
	 * Makes a copy of this object that will be inserted as a new row in table when saved.
	 * It creates a new object filling in the simple attributes, but skipping any primary
	 * keys that are defined for the table.
	 *
	 * If desired, this method can also make copies of all associated (fkey referrers)
	 * objects.
	 *
	 * @param      boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
	 * @return     Wein Clone of current object.
	 * @throws     PropelException
	 */
	public function copy($deepCopy = false)
	{
		// we use get_class(), because this might be a subclass
		$clazz = get_class($this);
		$copyObj = new $clazz();
		$this->copyInto($copyObj, $deepCopy);
		return $copyObj;
	}

	/**
	 * Returns a peer instance associated with this om.
	 *
	 * Since Peer classes are not to have any instance attributes, this method returns the
	 * same instance for all member of this class. The method could therefore
	 * be static, but this would prevent one from overriding the behavior.
	 *
	 * @return     WeinPeer
	 */
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new WeinPeer();
		}
		return self::$peer;
	}

	/**
	 * Declares an association between this object and a Weingut object.
	 *
	 * @param      Weingut $v
	 * @return     Wein The current object (for fluent API support)
	 * @throws     PropelException
	 */
	public function setWeingut(Weingut $v = null)
	{
		if ($v === null) {
			$this->setWgid(NULL);
		} else {
			$this->setWgid($v->getWgid());
		}

		$this->aWeingut = $v;

		// Add binding for other direction of this n:n relationship.
		// If this object has already been added to the Weingut object, it will not be re-added.
		if ($v !== null) {
			$v->addWein($this);
		}

		return $this;
	}


	/**
	 * Get the associated Weingut object
	 *
	 * @param      PropelPDO Optional Connection object.
	 * @return     Weingut The associated Weingut object.
	 * @throws     PropelException
	 */
	public function getWeingut(PropelPDO $con = null)
	{
		if ($this->aWeingut === null && ($this->wgid !== null)) {
			$c = new Criteria(WeingutPeer::DATABASE_NAME);
			$c->add(WeingutPeer::WGID, $this->wgid);
			$this->aWeingut = WeingutPeer::doSelectOne($c, $con);
			/* The following can be used additionally to
			   guarantee the related object contains a reference
			   to this object.  This level of coupling may, however, be
			   undesirable since it could result in an only partially populated collection
			   in the referenced object.
			   $this->aWeingut->addWeins($this);
			 */
		}
		return $this->aWeingut;
	}

	/**
	 * Clears out the collLagerts collection (array).
	 *
	 * This does not modify the database; however, it will remove any associated objects, causing
	 * them to be refetched by subsequent calls to accessor method.
	 *
	 * @return     void
	 * @see        addLagerts()
	 */
	public function clearLagerts()
	{
		$this->collLagerts = null; // important to set this to NULL since that means it is uninitialized
	}

	/**
	 * Initializes the collLagerts collection (array).
	 *
	 * By default this just sets the collLagerts collection to an empty array (like clearcollLagerts());
	 * however, you may wish to override this method in your stub class to provide setting appropriate
	 * to your application -- for example, setting the initial array to the values stored in database.
	 *
	 * @return     void
	 */
	public function initLagerts()
	{
		$this->collLagerts = array();
	}

	/**
	 * Gets an array of Lagert objects which contain a foreign key that references this object.
	 *
	 * If this collection has already been initialized with an identical Criteria, it returns the collection.
	 * Otherwise if this Wein has previously been saved, it will retrieve
	 * related Lagerts from storage. If this Wein is new, it will return
	 * an empty collection or the current collection, the criteria is ignored on a new object.
	 *
	 * @param      PropelPDO $con
	 * @param      Criteria $criteria
	 * @return     array Lagert[]
	 * @throws     PropelException
	 */
	public function getLagerts($criteria = null, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(WeinPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collLagerts === null) {
			if ($this->isNew()) {
			   $this->collLagerts = array();
			} else {

				$criteria->add(LagertPeer::WEINID, $this->weinid);

				LagertPeer::addSelectColumns($criteria);
				$this->collLagerts = LagertPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.


				$criteria->add(LagertPeer::WEINID, $this->weinid);

				LagertPeer::addSelectColumns($criteria);
				if (!isset($this->lastLagertCriteria) || !$this->lastLagertCriteria->equals($criteria)) {
					$this->collLagerts = LagertPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastLagertCriteria = $criteria;
		return $this->collLagerts;
	}

	/**
	 * Returns the number of related Lagert objects.
	 *
	 * @param      Criteria $criteria
	 * @param      boolean $distinct
	 * @param      PropelPDO $con
	 * @return     int Count of related Lagert objects.
	 * @throws     PropelException
	 */
	public function countLagerts(Criteria $criteria = null, $distinct = false, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(WeinPeer::DATABASE_NAME);
		} else {
			$criteria = clone $criteria;
		}

		if ($distinct) {
			$criteria->setDistinct();
		}

		$count = null;

		if ($this->collLagerts === null) {
			if ($this->isNew()) {
				$count = 0;
			} else {

				$criteria->add(LagertPeer::WEINID, $this->weinid);

				$count = LagertPeer::doCount($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return count of the collection.


				$criteria->add(LagertPeer::WEINID, $this->weinid);

				if (!isset($this->lastLagertCriteria) || !$this->lastLagertCriteria->equals($criteria)) {
					$count = LagertPeer::doCount($criteria, $con);
				} else {
					$count = count($this->collLagerts);
				}
			} else {
				$count = count($this->collLagerts);
			}
		}
		return $count;
	}

	/**
	 * Method called to associate a Lagert object to this object
	 * through the Lagert foreign key attribute.
	 *
	 * @param      Lagert $l Lagert
	 * @return     void
	 * @throws     PropelException
	 */
	public function addLagert(Lagert $l)
	{
		if ($this->collLagerts === null) {
			$this->initLagerts();
		}
		if (!in_array($l, $this->collLagerts, true)) { // only add it if the **same** object is not already associated
			array_push($this->collLagerts, $l);
			$l->setWein($this);
		}
	}


	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Wein is new, it will return
	 * an empty collection; or if this Wein has previously
	 * been saved, it will retrieve related Lagerts from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Wein.
	 */
	public function getLagertsJoinWeinkeller($criteria = null, $con = null, $join_behavior = Criteria::LEFT_JOIN)
	{
		if ($criteria === null) {
			$criteria = new Criteria(WeinPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collLagerts === null) {
			if ($this->isNew()) {
				$this->collLagerts = array();
			} else {

				$criteria->add(LagertPeer::WEINID, $this->weinid);

				$this->collLagerts = LagertPeer::doSelectJoinWeinkeller($criteria, $con, $join_behavior);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.

			$criteria->add(LagertPeer::WEINID, $this->weinid);

			if (!isset($this->lastLagertCriteria) || !$this->lastLagertCriteria->equals($criteria)) {
				$this->collLagerts = LagertPeer::doSelectJoinWeinkeller($criteria, $con, $join_behavior);
			}
		}
		$this->lastLagertCriteria = $criteria;

		return $this->collLagerts;
	}

	/**
	 * Resets all collections of referencing foreign keys.
	 *
	 * This method is a user-space workaround for PHP's inability to garbage collect objects
	 * with circular references.  This is currently necessary when using Propel in certain
	 * daemon or large-volumne/high-memory operations.
	 *
	 * @param      boolean $deep Whether to also clear the references on all associated objects.
	 */
	public function clearAllReferences($deep = false)
	{
		if ($deep) {
			if ($this->collLagerts) {
				foreach ((array) $this->collLagerts as $o) {
					$o->clearAllReferences($deep);
				}
			}
		} // if ($deep)

		$this->collLagerts = null;
			$this->aWeingut = null;
	}


  public function __call($method, $arguments)
  {
    if (!$callable = sfMixer::getCallable('BaseWein:'.$method))
    {
      throw new sfException(sprintf('Call to undefined method BaseWein::%s', $method));
    }

    array_unshift($arguments, $this);

    return call_user_func_array($callable, $arguments);
  }


} // BaseWein
